#include "MySyncObject.h"


CMySyncObject::CMySyncObject()
{
}

CMySyncObject::~CMySyncObject()
{
}

// 初期化
BOOL CMySyncObject::Initialize()
{
	pthread_mutex_init(&m_mutex, NULL);	// ミューテックスの初期化
	return(TRUE);
}

// 開放
BOOL CMySyncObject::Uninitialize()
{
	pthread_mutex_destroy(&m_mutex);	// ミューテックスの破棄	
	return(TRUE);
}


// ロック(所有権取得待ち)
BOOL CMySyncObject::Lock()
{
	pthread_mutex_lock(&m_mutex);		// ★所有権を取得するまで待つ
	return(TRUE);
}

// アンロック(所有権開放)
BOOL CMySyncObject::UnLock()
{
	pthread_mutex_unlock(&m_mutex);		// ★所有権を開放する
	Sleep(1);							// 他のスレッドに実行のチャンスを与える
										// UnLock/Lockが連続しないときは不要
	return(TRUE);
}

