#ifndef _stdThread_H_2B9D23FC_90BF_4898_B161_B894F01F6698
#define _stdThread_H_2B9D23FC_90BF_4898_B161_B894F01F6698

#define _NETWORK_APP

#include <iostream>
using namespace std;

#include	<stdio.h>
#include	<stdlib.h>
#include	<pthread.h>
#include	<unistd.h>
#include	<string.h>
#include	<sys/time.h>
#include	<errno.h>
#include	<sys/stat.h>
#include	<sys/types.h>
#include	<fcntl.h>
#include	<limits.h>
#include	<termios.h>
#ifdef _NETWORK_APP
#include	<netinet/tcp.h> 
#include	<sys/select.h>
#include	<netdb.h>
#include	<sys/socket.h>
#include	<netinet/in.h>
#include	<arpa/inet.h>
#include	<poll.h>
#include    <ifaddrs.h>					// getifaddrsを使うため
#include    <net/if.h>
#endif
#include	<math.h>


#ifdef _NETWORK_APP
#define		SOCKET_ERROR	(-1)
#define		INVALID_SOCKET	(-1)
#endif
#define		TRUE			(1)
#define		FALSE			(0)

typedef unsigned char		BYTE;
typedef int      			BOOL;
typedef unsigned int 		UINT;
typedef unsigned short		WORD;
// Linux  :LP64  long:64 int:32
// Windows:LLP64 long:32 int:32	pointerのみが64bitsになっている
//typedef unsigned long		DWORD;			// Windows
typedef unsigned int		DWORD;			// Linux
typedef BYTE				*LPBYTE;
typedef char				*LPSTR;
typedef const char			*LPCSTR;
typedef char				*LPTSTR;
typedef const char			*LPCTSTR;
typedef signed long long	SInt64;
typedef unsigned long long	UInt64;

#ifdef _NETWORK_APP
typedef int      			SOCKET;
#endif

//-----------------------------------------------------------------------
#define min(a,b)			(((a) < (b)) ? (a) : (b))
#define max(a,b)			(((a) > (b)) ? (a) : (b))

#define SAFE_FREE(p)	{ if(p) { free(p); (p)=NULL; } }
#define SAFE_DELETE(p)  { if(p) { delete (p);     (p)=NULL; } }
#define SAFE_DELETE_ARRAY(p)  { if(p) { delete[] (p); (p)=NULL; } }
//-----------------------------------------------------------------------
#ifdef _MSC_VER			// Windowsのとき
#define DISABLE_C4996   __pragma(warning(push)) __pragma(warning(disable:4996))
#define ENABLE_C4996    __pragma(warning(pop))
#else					// Linuxのとき
#define DISABLE_C4996
#define ENABLE_C4996
#endif

extern BOOL	gfEnableESC;

extern DWORD GetdwInterval(DWORD dwNow, DWORD dwPast);
extern DWORD timeGetTime();
extern int kbhit(void);
extern int getch(void);

#ifdef _NETWORK_APP
extern int DispNetErrorMsg(LPCSTR pszTitle);
#endif
extern void Sleep(DWORD dwMilliseconds);
extern BOOL EnableESC(FILE* stream);
extern void Locate(int iCol, int iRow, int iErase);
extern double	RoundOff(double dbBasic, int point);
#endif

